#include<bits/stdc++.h>
int n,q,niz[200005],a,b,res;
using namespace std;
int main(){
   scanf("%d %d",&n,&q);
   for(int i=1;i<=n;i++){
      scanf("%d" ,&niz[i]);
   }
   for(int i=1;i<=q;i++){
     scanf("%d %d",&a,&b);
     res=niz[a];
     for(int j=a;j<=b;j++){
        res=res&niz[j];
        if(res==0) break;
     }
     cout<<res<<endl;

   }


  return 0;
}